QuantLib: AbcdAtmVolCurve Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.6

- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
AbcdAtmVolCurve Class Reference

Abcd-interpolated at-the-money (no-smile) volatility curve. More...

`#include <ql/experimental/volatility/abcdatmvolcurve.hpp>`

Inheritance diagram for AbcdAtmVolCurve:
[legend]

## Public Member Functions
| AbcdAtmVolCurve (Natural settlementDays, const Calendar &cal, const std::vector< Period > &optionTenors, const std::vector< Handle< Quote > > &volsHandles, const std::vector< bool > inclusionInInterpolationFlag=std::vector< bool >(1, true), BusinessDayConvention bdc=Following, const DayCounter &dc=Actual365Fixed())
| floating reference date, floating market data
std::vector< Real > | k () const
| Returns k adjustment factors for option tenors used in interpolation.
Real | k (Time t) const
| Returns k adjustment factor at time t.
Real | a () const
Real | b () const
Real | c () const
Real | d () const
Real | rmsError () const
Real | maxError () const
EndCriteria::Type | endCriteria () const
TermStructure interface
virtual Date | maxDate () const
| the latest date for which the curve can return values
VolatilityTermStructure interface
Real | minStrike () const
| the minimum strike for which the term structure can return vols
Real | maxStrike () const
| the maximum strike for which the term structure can return vols
LazyObject interface
void | update ()
void | performCalculations () const
some inspectors
const std::vector< Period > & | optionTenors () const
const std::vector< Period > & | optionTenorsInInterpolation () const
const std::vector< Date > & | optionDates () const
const std::vector< Time > & | optionTimes () const
Visitability
virtual void | accept (AcyclicVisitor &)
Public Member Functions inherited from BlackAtmVolCurve
| BlackAtmVolCurve (BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| default constructor More...
| BlackAtmVolCurve (const Date &referenceDate, const Calendar &cal=Calendar(), BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| BlackAtmVolCurve (Natural settlementDays, const Calendar &, BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
Volatility | atmVol (const Period &optionTenor, bool extrapolate=false) const
| spot at-the-money volatility
Volatility | atmVol (const Date &maturity, bool extrapolate=false) const
| spot at-the-money volatility
Volatility | atmVol (Time maturity, bool extrapolate=false) const
| spot at-the-money volatility
Real | atmVariance (const Period &optionTenor, bool extrapolate=false) const
| spot at-the-money variance
Real | atmVariance (const Date &maturity, bool extrapolate=false) const
| spot at-the-money variance
Real | atmVariance (Time maturity, bool extrapolate=false) const
| spot at-the-money variance
Public Member Functions inherited from VolatilityTermStructure
virtual BusinessDayConvention | businessDayConvention () const
| the business day convention used in tenor to date conversion
Date | optionDateFromTenor (const Period &) const
| period/date conversion
| VolatilityTermStructure (BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| VolatilityTermStructure (const Date &referenceDate, const Calendar &cal, BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| VolatilityTermStructure (Natural settlementDays, const Calendar &cal, BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
Public Member Functions inherited from TermStructure
| TermStructure (const DayCounter &dc=DayCounter())
| default constructor More...
| TermStructure (const Date &referenceDate, const Calendar &calendar=Calendar(), const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| TermStructure (Natural settlementDays, const Calendar &, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual DayCounter | dayCounter () const
| the day counter used for date/time conversion
Time | timeFromReference (const Date &date) const
| date/time conversion
virtual Time | maxTime () const
| the latest time for which the curve can return values
virtual const Date & | referenceDate () const
| the date at which discount = 1.0 and/or variance = 0.0
virtual Calendar | calendar () const
| the calendar used for reference and/or option date calculation
virtual Natural | settlementDays () const
| the settlementDays used for reference date calculation
void | update ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< std::set< boost::shared_ptr< Observable > >::iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Extrapolator
void | enableExtrapolation (bool b=true)
| enable extrapolation in subsequent calls
void | disableExtrapolation (bool b=true)
| disable extrapolation in subsequent calls
bool | allowsExtrapolation () const
| tells whether extrapolation is enabled
Public Member Functions inherited from LazyObject
void | update ()
void | recalculate ()
void | freeze ()
void | unfreeze ()

## Protected Member Functions
BlackAtmVolCurve interface
virtual Real | atmVarianceImpl (Time t) const
| spot at-the-money variance calculation (k adjusted)
virtual Volatility | atmVolImpl (Time t) const
| spot at-the-money volatility calculation (k adjusted)
Calculations
These methods must be implemented in derived classes to perform the actual volatility calculations. When they are called, range check has already been performed; therefore, they must assume that extrapolation is required.
Protected Member Functions inherited from VolatilityTermStructure
void | checkStrike (Rate strike, bool extrapolate) const
| strike-range check
Protected Member Functions inherited from TermStructure
void | checkRange (const Date &d, bool extrapolate) const
| date-range check
void | checkRange (Time t, bool extrapolate) const
| time-range check
Protected Member Functions inherited from LazyObject
virtual void | calculate () const

## Additional Inherited Members
Protected Attributes inherited from TermStructure
bool | moving_
bool | updated_
Calendar | calendar_
Protected Attributes inherited from LazyObject
bool | calculated_
bool | frozen_

## Detailed Description

Abcd-interpolated at-the-money (no-smile) volatility curve.

blah blah

## Member Function Documentation

void update | ( |  | ) |
| virtual

This method must be implemented in derived classes. An instance of Observer does not call this method directly: instead, it will be called by the observables the instance registered with when they need to notify any changes.

Implements Observer.

void performCalculations | ( |  | ) | const
| virtual

This method must implement any calculations which must be (re)done in order to calculate the desired results.

Implements LazyObject.